package com.cxzx.sls;

import com.aliyun.openservices.aliyun.log.producer.LogProducer;
import com.aliyun.openservices.aliyun.log.producer.Producer;
import com.aliyun.openservices.aliyun.log.producer.ProducerConfig;
import com.aliyun.openservices.aliyun.log.producer.ProjectConfig;
import com.aliyun.openservices.aliyun.log.producer.errors.ProducerException;
import com.aliyun.openservices.log.common.LogItem;

public class AliyunLogger {
    private final Producer producer;
    private final String logStore;
    private final String project = "k8s-log-c4d23a31b8c6c4ed49e7fc1473dfd0c57";

    public AliyunLogger(String logStore) {

        this.logStore = logStore;

        ProducerConfig producerConfig = new ProducerConfig();
        producerConfig.setBatchSizeThresholdInBytes(3 * 1024 * 1024);
        producerConfig.setBatchCountThreshold(40960);

        producer = new LogProducer(producerConfig);
        producer.putProjectConfig(new ProjectConfig(project,
                "cn-chengdu.log.aliyuncs.com",
                "LTAI5tCb5r8efPipWaKSeCkE", "BsKtHRePUFBrfF9aA8b8sDTrox23cU"));

        Runtime.getRuntime().addShutdownHook(new Thread(this::close));
    }

    public void info(LogItem item) {
        try {
            item.PushBack("level", "info");
            producer.send(project, logStore, item);
        } catch (InterruptedException | ProducerException ignored) {
        }
    }

    public void error(LogItem item) {
        try {
            item.PushBack("level", "error");
            producer.send(project, logStore, item);
        } catch (InterruptedException | ProducerException ignored) {
        }
    }

    public void close() {
        try {
            producer.close();
        } catch (InterruptedException | ProducerException ignored) {
        }
    }

}
